/*
 * kedrigern_internal.h - Kedrigern (Milena TTS server for Raspberry Pi)
 * Copyright (C) Bohdan R. Rau 2019 <ethanak@polip.com>
 *
 * Kedrigern is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Kedrigern is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Kedrigern.  If not, write to:
 * 	The Free Software Foundation, Inc.,
 * 	51 Franklin Street, Fifth Floor
 * 	Boston, MA  02110-1301, USA.
 */

#ifndef MILERVER_H
#define MILERVER_H

extern void initMilena(const char *udic);
extern char * convertMilena(char *msg);

extern void initAudio(char *name);
extern void startAudio(int samplefreq);
extern void playSound(char *bufor, int n);
extern void finalizeAudio(void);
extern void showAudioDrivers(void);

#define constrain(a, b, c) ((a < (b)) ? (b): (a > (c)) ? (c) : a)

enum {
    PHONE_BLANK = 0,
    PHONE_A,
    PHONE_E,
    PHONE_I,
    PHONE_O,
    PHONE_U,
    PHONE_Y,
    PHONE_P,
    PHONE_M,
    PHONE_F,
    PHONE_W,
    PHONE_ETC,
    PHONE_SIL,
    PHONE_REST,
    PHONE_COUNT};
    
struct mouthem {
    unsigned int shape:5;
    unsigned int stress:3;
    int time:24;
};

#define BANK_COUNT 2

extern void startMouth(char *pho, double factor);
extern void initMouth(int dev, int rot, int bri, int nodev,
            int serv, int s_start, int s_end, int ablank,
            int bank, const char *shape);
extern void finalizeMouth();
extern void shapeMouth(int shape);
extern void setMouth(int ti);
extern void brightnessMouth(int b);
extern void powerMouth(int b);
extern void phonemMouth(int shape);

#endif
